<template>
  <div
      :class="['map', 'l1']"
      :style="{
        'width': (stepScale === 2 ? lWidth : 0) + 'px',
        'height': (stepScale === 2 ? lHeight : 0) + 'px',
        'transform': stepScale === 2 ? 'translate(' + left + 'px, ' + top + 'px) scale(' + lScale + ')' : '',
        'position': stepScale === 2 ? 'absolute' : 'static',
        'will-change': stepScale === 2 ? 'transform' : '',
        'display': visible ? '' : 'none'
      }"
  >
    <MapX4
        v-for="item of sub"
        :key="Math.random(item)"
        :x="item.x"
        :y="item.y"
        :width="item.width"
        :height="item.height"
        :els="item.els"
        :sub="item.sub"
        :tx="tx"
        :ty="ty"
        :scale="scale"
        :cw="cw"
        :ch="ch"
        :step-scale="stepScale"
        :l1x="x"
        :l1y="y"
    />
  </div>
</template>

<script>
import MapX4 from "@/components/x1/MapX4";
export default {
  name: "MapX2",
  components : { MapX4 },
  props: {
    x: Number,
    y: Number,
    width: Number,
    height: Number,
    els: Array,
    sub: Array,
    tx: Number,
    ty: Number,
    scale: Number,
    cw: Number,
    ch: Number,
    stepScale: Number
  },
  computed: {
    lWidth () {
      return this.width * 2;
    },
    lHeight () {
      return this.height * 2;
    },
    lScale () {
      return this.scale / 2;
    },
    left () {
      return this.x * this.scale + this.tx;
    },
    right () {
      return this.left + this.lWidth * this.scale;
    },
    top () {
      return this.y * this.scale + this.ty;
    },
    bottom () {
      return this.top + this.lHeight * this.scale;
    },
    hVisible () {
      return this.left < this.cw && this.right > 0;
    },
    vVisible () {
      return this.top < this.ch && this.bottom > 0;
    },
    visible () {
      return (this.hVisible && this.vVisible && this.stepScale === 2) || this.stepScale !== 2;
    }
  }
}
</script>
